[Website](https://www.cortex.dev) • [Slack](https://community.cortex.dev) • [Docs](https://docs.cortex.dev)

<br>

<img src='https://s3-us-west-2.amazonaws.com/cortex-public/logo.png' height='42'>

<br>

# Serverless containers on AWS

Deploy, manage, and scale containers without managing infrastructure.

<br>

## Build APIs faster

* **Realtime APIs** - respond to requests in real-time and autoscale based on in-flight request volumes.
* **Batch APIs** - run distributed and fault-tolerant batch processing jobs on-demand.
* **Async APIs** - process requests asynchronously and autoscale based on request queue length.

<br>

## Scale without limits

* **No resource limits** - allocate as much CPU, GPU, and memory as each workload requires.
* **No cold starts** - keep a minimum number of API replicas running to ensure that requests are handled in real-time.
* **No timeouts** - run workloads for as long as you want.

<br>

## Reduce your AWS spend

* **Spot instance management** - Cortex runs workloads on spot instances and fall back to on-demand instances to ensure reliability.
* **Multi-instance type clusters** - Cortex runs different workloads on different EC2 instances to ensure efficient resource utilization.
* **Efficient autoscaling** - Cortex optimizes the autoscaling behavior of each workload to minimize idle resources.
